/* debug.h   definitions and constants related to the debugging module debug.c */

#ifndef __debug_h__
#define __debug_h__

/* debug level constants are additive */
#define DL_NONE			0					/* don't print any debugging info/don't even create a file */
#define DL_INFO			1					/* information message, normally printed on the screen */
#define DL_AUX			2					/* auxiliary variable values and other normally not interesting messages  */
#define DL_SIMULATOR	4					/* calls to simulator are printed */
#define DL_SIMSTATUS	8					/* on each call to simulator, robot status is printed */
#define DL_DEBUGGING	16					/* low level code debugging messages */
#define DL_DESPERATE	32
#define DL_ALL		65535					/* complete detailed debugging info */

#define DEBUG_FILENAME		"cargo_debug.log"	/* debug info into this file */

/* function prototypes */
void initdebug(int screen_debug_level, int file_debug_level);
void debugmsg(int debuglevel, char *msg);
void debugmsg1int(int debuglevel, char *msg, int num);
void debugmsg2int(int debuglevel, char *msg, int num1, int num2);
void debugmsg1double(int debuglevel, char *msg, double num);
void debugmsg2double(int debuglevel, char *msg, double num1, double num2);
void debugmsg1long(int debuglevel, char *msg, long num);
void debugmsg2long(int debuglevel, char *msg, long num1, long num2);

#endif //__debug_h__